require 'omniauth/strategies/oauth2'
require 'net/http'

module OmniAuth
  module Strategies
    class Lexoffice < OmniAuth::Strategies::OAuth2
      # Give your strategy a name.
      option :name, "lexoffice"

      # This is where you pass the options you would pass when
      # initializing your consumer from the OAuth gem.
      option :client_options, {:site =>  "https://app.lexoffice.de",
                               :authorize_url => 'https://app.lexoffice.de/api/oauth2/authorize',
                               :token_url => 'https://app.lexoffice.de/api/oauth2/token',
                               :response_type => 'code'}

      #option :iframe, true
      #option :callback_path, "/auth/lexoffice/callback"

      # These are called after authentication has succeeded. If
      # possible, you should try to set the UID without making
      # additional calls (if the user id is returned with the token
      # or as a URI parameter). This may not be possible with all
      # providers.






      def setup_phase
        super

      end

      def authorize_params
        # params = super
        params = {client_id: options.client_id, response_type:'code'}
        params.merge!(super)
      end

      def token_params
        options.token_params.merge!(:headers => {'Authorization' => basic_auth_header(options.client_id,options.client_secret), 'Accept' => 'application/json' })
      end

      def request_phase
        #authorize call
        redirect client.auth_code.authorize_url({:redirect_uri => callback_url}.merge(authorize_params))
      end

      def callback_url
        return full_host + script_name + callback_path + "?shop=#{request.params["shop"]}" if request.params["shop"].present?
        full_host + script_name + callback_path
      end

      def redirect(uri)
        r = Rack::Response.new
        if options[:iframe]
          r.write("<script type='text/javascript' charset='utf-8'>
            window.setTimeout(function() {
                    window.top.location.href = '#{uri}'; // this window will not open
                }, 100);
          </script>")
        else
          r.write("Redirecting to #{uri}...")
          r.redirect(uri)
        end

        r.finish
      end




      def basic_auth_header(client_id, client_secret)
        'Basic ' + Base64.encode64(client_id + ':' + client_secret).delete("\n")
      end

    end
  end
end